﻿'Title:                 Rotator Control Panel
'Author:                H.NAMVA
'Original issued on：   2013.11.18 ver 1.00
'Last updated on:       2013.12.09 ver 1.01
Public Class Form1
    Private RxBuf(1024) As Byte
    Private RxBufLength As Integer
    Private strAzimuth As String = ""

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim availableSerialPorts As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = My.Computer.Ports.SerialPortNames
        Try
            If availableSerialPorts.Contains(COMPort.PortName) Then
                If COMPort.IsOpen Then
                    MessageBox.Show(COMPort.PortName & " is already OPENED", "error", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Close()
                Else
                    COMPort.Open()
                End If
            Else
                MsgBox(COMPort.PortName & " is not available")
                Me.Close()
            End If
        Catch ex As Exception
            Debug.Print(ex.Message & " in Form1_Load")
            Me.Close()
        End Try
    End Sub
    Delegate Sub ModifyAzimuthLabel()

    Sub ModifyAzimuth()
        Dim temp As String = ""
        Dim direction As Integer
        Dim overlap As Integer
        Dim motor As Integer

        Try
            direction = Integer.Parse(strAzimuth)
            motor = direction Mod 10
            direction = direction \ 10
            lblAzimuth.Text = direction.ToString
            If direction >= 360 Then
                overlap = direction - 360
                lblAz2.Text = "(" & overlap.ToString & ")"
                lblAz2.Visible = True
            Else
                lblAz2.Visible = False
            End If
            If motor = 1 Then 'CW
                btnCW.BackColor = Color.LimeGreen
            ElseIf motor = 2 Then 'CCW
                btnCCW.BackColor = Color.LimeGreen
            Else
                btnCW.BackColor = Color.Silver
                btnCCW.BackColor = Color.Silver
            End If

            TxbRx.AppendText(strAzimuth & vbCrLf)
            If Len(TxbRx.Text) > (TxbRx.MaxLength - 1000) Then
                'サイズが大きくなり過ぎたら、データを半分消去する
                temp = Mid(TxbRx.Text, TxbRx.MaxLength / 2, Len(TxbRx.Text))
                TxbRx.Text = temp
            End If
        Catch ex As Exception
            Debug.Print(ex.Message & "in ModifyAzimuth")
        End Try
        
    End Sub

    Private Sub COMPort_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles COMPort.DataReceived
        Dim ModAzi As New ModifyAzimuthLabel(AddressOf ModifyAzimuth)
        Try
            strAzimuth = COMPort.ReadLine()
            Debug.Print("data received: " & strAzimuth)
            lblAzimuth.Invoke(ModAzi)
        Catch ex As Exception
            Debug.Print(ex.Message & vbCrLf & "RxBufLength = " & RxBufLength.ToString)
        End Try
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        COMPort.Write("D")
    End Sub

    Private Sub btnCW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCW.Click
        COMPort.Write("A")
    End Sub

    Private Sub btnCCW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCCW.Click
        COMPort.Write("B")
    End Sub

    Private Sub btnSTOP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSTOP.Click
        COMPort.Write("C")
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        Dim preset As Integer
        Try
            preset = Integer.Parse(TxbPreset.Text)
            COMPort.Write(preset.ToString("D3") & "E")
        Catch ex As Exception
            MsgBox("Invalid Preset Value")
            Debug.Print(ex.Message & "in btnPrest")
        End Try
    End Sub
End Class
